Subject: RE: [IPsec] Fwd: Last Call: draft-ietf-ipsecme-ikev2-resumption (IKEv2 Session Resumption) to Proposed Standard

From: Yaron Sheffer <[email-masked]>
Date: Thu, 3 Sep 2009 00:15:40 +0300

Hi Peny,

Thank you for reviewing this draft. Please see my comments below.

Regards,
	Yaron

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of
> Peny Yang
> Sent: Wednesday, September 02, 2009 17:18
> To: [email-masked]
> Cc: IPsecme WG
> Subject: [IPsec] Fwd: Last Call: draft-ietf-ipsecme-ikev2-resumption
> (IKEv2 Session Resumption) to Proposed Standard
> 
> Sorry, I should cc IPsec mail list. Comments are sent again.
> 
> Hi, floks:
> 
> I have two comments on the draft of IKEv2 Session Resumption:
> 
> 1) Sorry, I have to talk about my concern on the new
> IKE_SESSION_RESUME. In WG last call, actually I made this comment.
> However, no feedback was given, maybe because my comment was a little
> late for WG last call. So, I just copy it here again as a comment for
> IESG last call.
> 
> Well,  we've discussed pros and cons of IKE_SA_INIT and
> IKE_SESSION_RESUME for quite a long time. However, IMHO, the consensus
> is still not fully achieved on this item. So far, I still prefer to
> choosing extended IKE_SA_INIT for ticket presenting. This solution is
> specified in http://tools.ietf.org/html/draft-xu-ike-sa-sync-01
> 
> As a summary, the virtues are as follows:
> - RFC5077 (TLS session resumption) also uses the similar scheme, which
> extends the message of clienthello with session ticket extension. The
> extended IKE_SA_INIT solution has the similar way. It's easy to extend
> the base IKEv2 protocol stack to support session resumption.
> - Considering the case of failing session resumption, the extended
> IKE_SA_INIT solution can save one round trip.
> - As indicated in 4.3.3 IKE_AUTH exchange, IKE_AUTH must be initiated
> after IKE_SESSION_RESUME. In this sense, the extended IKE_SA_INIT way
> need less code to be supported compared with IKE_SESSION_RESUME.
> 
> The down side:
> - some people thought the way of extended IKE_SA_INIT will make the
> base IKEv2 protocol stack more complex. IMHO, it's an issue of
> implementation.
> Again, I still support to use extended IKE_SA_INIT for ticket
> presenting instead of IKE_SESSION_RESUME.
> 
[YS] I see the merits of extending IKE_SA_INIT to support resumption, and in
fact an early version of our work did exactly that. But the working group
gave us a clear direction to use a separate exchange, and this is where we
disagree: I believe we did have a strong WG consensus that the
implementation benefits of having a separate exchange (i.e. not overloading
even more the non-trivial IKE_SA_INIT exchange) outweigh the benefits of the
alternative.

> 2) Maybe I missed some discussions.
> There is the case: responder may receives a ticket for an IKE SA that
> is still active and if the responder accepts it. In one of previous
> versions of this draft, there once was some description on this case.

[YS] I believe you are referring to the text now in Sec. 4.3.4.

> I know that how a client detects the need for resumption is out of the
> scope of this draft. But, there is the possibility that IPsec client
> may be continuously deceived and believe the fail of IPsec gateway. It
> may continuously present the ticket and update the ticket. In this
> sense, IMHO, this draft should take care of this case.
> 
[YS] If I understand the scenario correctly, it is similar to an attacker
repeatedly sending notifications to an IKE client, making it believe that
the IKE exchange has failed and needs to be reinitiated. This attack against
plain-vanilla IKE would be much more CPU-intensive to the client and to the
(real) gateway, compared to repeated session resumption. Even when you
factor in the cost of generating a new ticket. Moreover, the regular IKEv2
anti-DOS cookie mechanism is supported by IKE_SESSION_RESUME as well.

> BRG
> Peny
> 
> On Mon, Aug 31, 2009 at 10:09 PM, The IESG<[email-masked]> wrote:
> > The IESG has received a request from the IP Security Maintenance and
> > Extensions WG (ipsecme) to consider the following document:
> >
> > - 'IKEv2 Session Resumption '
> >   <draft-ietf-ipsecme-ikev2-resumption-07.txt> as a Proposed Standard
> >
> > The IESG plans to make a decision in the next few weeks, and solicits
> > final comments on this action.  Please send substantive comments to the
> > [email-masked] mailing lists by 2009-09-14. Exceptionally,
> > comments may be sent to [email-masked] instead. In either case, please
> > retain the beginning of the Subject line to allow automated sorting.
> >
> > The file can be obtained via
> > http://www.ietf.org/internet-drafts/draft-ietf-ipsecme-ikev2-resumption-
> 07.txt
> >
> >
> > IESG discussion can be tracked via
> >
> https://datatracker.ietf.org/public/pidtracker.cgi?command=view_id&dTag=17
> 990&rfc_flag=0
> >
> > _______________________________________________
> > IPsec mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/ipsec
> >
> _______________________________________________
> IPsec mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ipsec
> 
> Scanned by Check Point Total Security Gateway.

---

From: Peny Yang <[email-masked]>
Date: Wed, 2 Sep 2009 10:32:07 +0800

Hi, floks:

The down side:

BRG
Peny

On Mon, Aug 31, 2009 at 10:09 PM, The IESG<[email-masked]> wrote:
> http://www.ietf.org/internet-drafts/draft-ietf-ipsecme-ikev2-resumption-07.txt
>
>
> https://datatracker.ietf.org/public/pidtracker.cgi?command=view_id&dTag=17990&rfc_flag=0
>

---

From: Peny Yang <[email-masked]>
Date: Thu, 3 Sep 2009 21:57:31 +0800

Hi, Yaron:

Please check my response inlines:

BRG
Peny

> implementation benefits of having a separate exchange (i.e.) outweigh the benefits of the
> alternative.

[Peny] I know WG chair have the right to judge "rough consensus".
However, I can't agree that IPsecme WG has achieved the so called
"strong consensus" on this issue. Maybe IESG can further judge it.
I also can't agree "benefits of having a separate exchange outweigh
the benefits of the alternative". Actually, we didn't achieve
consensus on it yet.

> not overloading even more the non-trivial IKE_SA_INIT exchange
[Peny] I am sorry. I just can't see any evidence that the solution of
extending IKE_SA_INIT extension will *OVERLOAD* current IKE_SA_INIT
exchange? Or I missed something?

> [YS] I believe you are referring to the text now in Sec. 4.3.4.
[Peny] OK. This is the part I referred to. But, it can't deal with the
issue when IPsec client *continuously* believes failure of gateway.

> the IKE exchange has failed and needs to be reinitiated.
[Peny] Well, this case may not cause this problem. If attacker has
IPsec connection with the client, the client will only believe the
attacker fails, not Gateway.
Here is one of the cases. Sometimes, temporary unavailability of
network access may also cause this problem. For example, in mobile
network, mobile terminals may lose radio resources in some time. In
this situation, all the packets outward of client will be timeout.
Then IKEv2 protocol stack has the possibility to believe failure of
gateway. It will send one or more message to initiate the session
resumption. However, as far as I know, many cellular card now will not
discard the packets when radio resources lose for a while. It will
buffer the packets and send them out when radio resources are
available.

> This attack against
> (real) gateway, compared to repeated session resumption.
[Peny] Well, I see your logic. Basically, even if gateway may not be
overloaded, it does not mean gateway will do something in vain.

> Even when you
[Peny] I did not mean this. Sorry for some confusing.

---

From: Peny Yang <[email-masked]>
Date: Thu, 3 Sep 2009 22:08:20 +0800

On Thu, Sep 3, 2009 at 5:11 PM, Tero Kivinen<[email-masked]> wrote:
> Yaron Sheffer writes:
> I agree on that (both to the WG having consensus and also that using
> separate exchange is better).
> Regardless what notifications or ICMP messages you send to any of the
> IKE end points that MUST NOT cause them to consider IKE SA failed. It
> "MUST conclude that the other endpoind has failed only when repeated
> attemtps to contact it have gone unanswered for timeout period or when
> a cryptographically protected INITIAL_CONTACT notification is received
> on a different IKE SA to the same authenticated identity." (RFC 4306
> section 2.4)
>
> Notifications and ICMP messages may trigger other end to send empty
> INFORMATIONAL message to check whether the other end is alive or not
> and only if that times out then the other end is considered dead.
>
> This means this kind of attack is not possible with notifications and
> ICMP.
[Peny] Agree. I did not mean this kind of attacking originally.

>
> On the other hand I do agree with Peny that, as resumption draft makes
> it out of scope for this draft, how a client detects the need of
> resumption, we might need more text explaining this attack. I.e. we
> might need to add text to security considerations which says that the
> client implementations should not trust any untrusted source when they
> are trying to detect whether the resumption is needed.
[Peny] Agree. I also think we need more text to clarify this issue.
In this meanwhile, I think the way in section 4.3.4 is not
appropriate. Gateway should not silently delete the related SAs in
this case. One possible solution is to use the anti-DOS cookie
mechanism of IKEv2 to handle this issue.

> --
> [email-masked]

---

From: Tero Kivinen <[email-masked]>
Date: Thu, 3 Sep 2009 12:11:41 +0300

---

From: Hui Deng <[email-masked]>
Date: Tue, 22 Sep 2009 22:39:38 +0800

Comments inline, thanks

> separate exchange is better).
[Hui] I don't think so. IMO, in the list, the comparison of extended
IKE_SA_INIT exchange and IKE_SESSION_RESUME still did not have a consensus yet.
It was a ballot in the mailing list in the begining, and it is quite
clear more people opposing
sepaparate exchange, we could do one more round ballot if needed.

> are trying to detect whether the resumption is needed.

[Hui] I also agree with Peny and Tero. Although way of detecting
failure of gateways is out of the scope of current charter, WG draft
should at least handle the issues incurred by mis-judgement of client.

thanks

-Hui

---

From: Yaron Sheffer <[email-masked]>
Date: Tue, 22 Sep 2009 17:46:17 +0300

Hi Hui,

Thank you for your comments. Regarding your second comment, please see http://tools.ietf.org/html/draft-ietf-ipsecme-ikev2-resumption-08#section-9.4

Regards,
	Yaron

> From: Hui Deng [mailto:[email-masked]]
> Sent: Tuesday, September 22, 2009 17:40
> To: Tero Kivinen
> Cc: Yaron Sheffer; IPsecme WG; [email-masked]; Peny Yang
> Subject: Re: [IPsec] Fwd: Last Call: draft-ietf-ipsecme-ikev2-resumption

Email secured by Check Point

Email secured by Check Point